diff --git a/include/sysemu/kvm.h b/include/sysemu/kvm.h
index 3db19ff..6756e16 100644
--- a/include/sysemu/kvm.h
+++ b/include/sysemu/kvm.h
@@ -168,11 +168,11 @@ int kvm_arch_process_async_events(CPUState *cpu);
 int kvm_arch_get_registers(CPUState *cpu);
 
 /* state subset only touched by the VCPU itself during runtime */
-#define KVM_PUT_RUNTIME_STATE   1
+#define KVM_REGSYNC_RUNTIME_STATE   1
 /* state subset modified during VCPU reset */
-#define KVM_PUT_RESET_STATE     2
+#define KVM_REGSYNC_RESET_STATE     2
 /* full state set, modified during initialization or on vmload */
-#define KVM_PUT_FULL_STATE      3
+#define KVM_REGSYNC_FULL_STATE      3
 
 int kvm_arch_put_registers(CPUState *cpu, int level);
 
diff --git a/kvm-all.c b/kvm-all.c
index fc0c6e7..aa58b74 100644
--- a/kvm-all.c
+++ b/kvm-all.c
@@ -1512,7 +1512,7 @@ void kvm_cpu_synchronize_post_reset(CPUArchState *env)
 {
     CPUState *cpu = ENV_GET_CPU(env);
 
-    kvm_arch_put_registers(cpu, KVM_PUT_RESET_STATE);
+    kvm_arch_put_registers(cpu, KVM_REGSYNC_RESET_STATE);
     cpu->kvm_vcpu_dirty = false;
 }
 
@@ -1520,7 +1520,7 @@ void kvm_cpu_synchronize_post_init(CPUArchState *env)
 {
     CPUState *cpu = ENV_GET_CPU(env);
 
-    kvm_arch_put_registers(cpu, KVM_PUT_FULL_STATE);
+    kvm_arch_put_registers(cpu, KVM_REGSYNC_FULL_STATE);
     cpu->kvm_vcpu_dirty = false;
 }
 
@@ -1539,7 +1539,7 @@ int kvm_cpu_exec(CPUArchState *env)
 
     do {
         if (cpu->kvm_vcpu_dirty) {
-            kvm_arch_put_registers(cpu, KVM_PUT_RUNTIME_STATE);
+            kvm_arch_put_registers(cpu, KVM_REGSYNC_RUNTIME_STATE);
             cpu->kvm_vcpu_dirty = false;
         }
 
diff --git a/target-i386/kvm.c b/target-i386/kvm.c
index 3acff40..fc84922 100644
--- a/target-i386/kvm.c
+++ b/target-i386/kvm.c
@@ -1049,7 +1049,7 @@ static int kvm_put_msrs(X86CPU *cpu, int level)
         kvm_msr_entry_set(&msrs[n++], MSR_LSTAR, env->lstar);
     }
 #endif
-    if (level == KVM_PUT_FULL_STATE) {
+    if (level == KVM_REGSYNC_FULL_STATE) {
         /*
          * KVM is yet unable to synchronize TSC values of multiple VCPUs on
          * writeback. Until this is fixed, we only write the offset to SMP
@@ -1065,7 +1065,7 @@ static int kvm_put_msrs(X86CPU *cpu, int level)
      * too heavy for normal writeback. Limit them to reset or full state
      * updates.
      */
-    if (level >= KVM_PUT_RESET_STATE) {
+    if (level >= KVM_REGSYNC_RESET_STATE) {
         kvm_msr_entry_set(&msrs[n++], MSR_KVM_SYSTEM_TIME,
                           env->system_time_msr);
         kvm_msr_entry_set(&msrs[n++], MSR_KVM_WALL_CLOCK, env->wall_clock_msr);
@@ -1504,7 +1504,7 @@ static int kvm_put_vcpu_events(X86CPU *cpu, int level)
     events.sipi_vector = env->sipi_vector;
 
     events.flags = 0;
-    if (level >= KVM_PUT_RESET_STATE) {
+    if (level >= KVM_REGSYNC_RESET_STATE) {
         events.flags |=
             KVM_VCPUEVENT_VALID_NMI_PENDING | KVM_VCPUEVENT_VALID_SIPI_VECTOR;
     }
@@ -1653,7 +1653,7 @@ int kvm_arch_put_registers(CPUState *cpu, int level)
     if (ret < 0) {
         return ret;
     }
-    if (level >= KVM_PUT_RESET_STATE) {
+    if (level >= KVM_REGSYNC_RESET_STATE) {
         ret = kvm_put_mp_state(x86_cpu);
         if (ret < 0) {
             return ret;
diff --git a/target-ppc/kvm.c b/target-ppc/kvm.c
index 436ca47..f705b4c 100644
--- a/target-ppc/kvm.c
+++ b/target-ppc/kvm.c
@@ -489,7 +489,7 @@ int kvm_arch_put_registers(CPUState *cs, int level)
         env->tlb_dirty = false;
     }
 
-    if (cap_segstate && (level >= KVM_PUT_RESET_STATE)) {
+    if (cap_segstate && (level >= KVM_REGSYNC_RESET_STATE)) {
         struct kvm_sregs sregs;
 
         sregs.pvr = env->spr[SPR_PVR];
@@ -524,7 +524,7 @@ int kvm_arch_put_registers(CPUState *cs, int level)
         }
     }
 
-    if (cap_hior && (level >= KVM_PUT_RESET_STATE)) {
+    if (cap_hior && (level >= KVM_REGSYNC_RESET_STATE)) {
         uint64_t hior = env->spr[SPR_HIOR];
         struct kvm_one_reg reg = {
             .id = KVM_REG_PPC_HIOR,
diff --git a/target-s390x/kvm.c b/target-s390x/kvm.c
index 6ec5e6d..e7b5ad9 100644
--- a/target-s390x/kvm.c
+++ b/target-s390x/kvm.c
@@ -117,7 +117,7 @@ int kvm_arch_put_registers(CPUState *cs, int level)
     }
 
     /* Do we need to save more than that? */
-    if (level == KVM_PUT_RUNTIME_STATE) {
+    if (level == KVM_REGSYNC_RUNTIME_STATE) {
         return 0;
     }
 